import 'package:example/login_controller.dart';
import 'package:flutter/material.dart';

void main() {
  runApp(MaterialApp(
    home: MyApp(),
  ));
}

class MyApp extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: 'Flutter Demo',
        theme: ThemeData(
          primarySwatch: Colors.blue,
        ),
        home: Scaffold(
          appBar: AppBar(
            title: Text("Hola"),
          ),
          body: Center(
            child: LoginWidget(),
          ),
        ));
  }
}

class LoginWidget extends StatefulWidget {
  @override
  _LoginWidgetState createState() => _LoginWidgetState();
}

class _LoginWidgetState extends State<LoginWidget> {
  final controller = LoginController();

  final usernameController = TextEditingController();
  final passwordController = TextEditingController();


  _LoginWidgetState(){
    usernameController.addListener(() {
      controller.username = usernameController.text;
      print('Setting the value');
    });
    passwordController.addListener(() {
      controller.password = passwordController.text;
    });
  }

  @override
  Widget build(BuildContext context) {
    print('building the widget');
    return Center(
      child: Column(
        children: <Widget>[
          TextField(
            controller: usernameController,
            decoration: InputDecoration(
              border: OutlineInputBorder(),
              labelText: 'Username',
            ),
          ),
          TextField(
            controller: passwordController,
            obscureText: true,
            decoration: InputDecoration(
              border: OutlineInputBorder(),
              labelText: 'Password',
            ),
          ),
          ValueListenableBuilder<String>(
            valueListenable: controller.usernameListenable,
            builder: (context, snapshot, _) {
              print('building username');
              return Text('${snapshot}');
            },
          ),
          ValueListenableBuilder<double>(
            valueListenable: controller.sizeListenable,
            builder: (context, snapshot, _) {
              return Slider(
                value: snapshot,
                min: 0,
                max: 100,
                divisions: 10,
                label: '${snapshot}',
                onChanged: (value) {
                  controller.size = value;
                },
              );
            },
          ),
          ValueListenableBuilder<double>(
            valueListenable: controller.sizeListenable,
            builder: (context, snapshot, _) {
              return Text('${snapshot}');
            },
          ),
          RaisedButton(
            child: Text('Login'),
            onPressed: () {
              controller.login();
            },
          ),
          ValueListenableBuilder<LoginState>(
            valueListenable: controller.loginStateListenable,
            builder: (context, snapshot, _) {
              return Text('${snapshot}');
            },
          )
        ],
      ),
    );
  }

  @override
  void dispose() {
    super.dispose();
    controller.dispose();
  }
}